ALTER TABLE  `#__osma_anagrafica_pistole` ADD `ignoraScadenza` BOOLEAN NOT NULL DEFAULT FALSE AFTER `scadenzaPeriodica` ;

CREATE TABLE IF NOT EXISTS `#__osma_amministrazione_scadenziario` (
    `idScadenza` INT(11) NOT NULL AUTO_INCREMENT,
    `idGestore` INT(11) NOT NULL,
    `data` DATE NOT NULL,
    `scadenza` INT(11) NOT NULL,
    `inserted` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    `modified` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,

    PRIMARY KEY (`idScadenza`)
);

CREATE TABLE IF NOT EXISTS `#__osma_amministrazione_rvmp` (
    `idRichiesta` INT(11) NOT NULL AUTO_INCREMENT,
    `progressivo` INT(11) NOT NULL,
    `idPreventivo` INT(11) NULL,
    `idGestore` INT(11) NOT NULL,
    `idPistole` TEXT NOT NULL,
    `intestazione` TEXT NOT NULL,
    `utenteMetrico` TEXT NOT NULL,
    `richiestaVerifica` BOOLEAN NOT NULL,
    `dataVerifica` DATE NOT NULL,
    `motivazione` TEXT NOT NULL,
    `manuale` BOOLEAN NOT NULL DEFAULT FALSE,
    `inserted` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    `modified` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,

    PRIMARY KEY (`idRichiesta`)
);

CREATE TABLE IF NOT EXISTS `#__osma_anagrafica_banche` (
    `idBanca` INT(11) NOT NULL AUTO_INCREMENT,
    `intestazione` VARCHAR(255) NOT NULL,
    `iban` VARCHAR(255) NOT NULL,
    `denominazione` VARCHAR(255) NOT NULL,
    `inserted` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    `modified` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,

    PRIMARY KEY (`idBanca`)
);

CREATE TABLE IF NOT EXISTS `#__osma_magazzino_codici` (
    `idCodice` INT(11) NOT NULL AUTO_INCREMENT,
    `codice` VARCHAR(255) NOT NULL,
    `inserted` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    `modified` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,

    PRIMARY KEY (`idCodice`)
);

CREATE TABLE IF NOT EXISTS `#__osma_amministrazione_preventivi` (
    `idPreventivo` INT(11) NOT NULL AUTO_INCREMENT,
    `idCliente` INT(11) NOT NULL,
    `idGestore` INT(11) NOT NULL,
    `utenzaDestinazione` VARCHAR(50) NOT NULL,
    `utenzaSpettabile` VARCHAR(50) NOT NULL,
    `destinazione` TEXT NOT NULL,
    `spettabile` TEXT NOT NULL,
    `idBanca` INT(11) NOT NULL,
    `tipoPagamento` INT(11) NOT NULL,
    `totaleImponibile` DECIMAL(10,2) NOT NULL,
    `totaleIva` DECIMAL(10,2) NOT NULL,
    `totalePreventivo` DECIMAL(10,2) NOT NULL,
    `fatturato` BOOLEAN NOT NULL,
    `inserted` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    `modified` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,

    PRIMARY KEY (`idPreventivo`)
);

CREATE TABLE IF NOT EXISTS `#__osma_amministrazione_preventivi_voci` (
    `idVoce` INT(11) NOT NULL AUTO_INCREMENT,
    `idPreventivo` INT(11) NOT NULL,
    `idCodice` INT(11) NOT NULL,
    `descrizione` VARCHAR(255) NOT NULL,
    `um` VARCHAR(10) NOT NULL,
    `prezzo` DECIMAL(10,2) NOT NULL,
    `quantita` INT(11) NOT NULL,
    `sconto` INT(11) NOT NULL,
    `totale` DECIMAL(10,2) NOT NULL,
    `iva` INT(11) NOT NULL,
    `inserted` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    `modified` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,

    PRIMARY KEY (`idVoce`)
);

CREATE TABLE IF NOT EXISTS `#__osma_amministrazione_preventivi_pistole` (
    `idPrevPistola` INT(11) NOT NULL AUTO_INCREMENT,
    `idPreventivo` INT(11) NOT NULL,
    `idPistola` INT(11) NOT NULL,
    `inserted` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    `modified` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,

    PRIMARY KEY (`idPrevPistola`)
);