<?php

// No direct access to this file
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.modelitem');

class OsmaModelChiamata extends JModelItem
{

    public function getItem()
    {
        $db = JFactory::getDbo();
        $idChiamata = JRequest::getVar('idChiamata');
        if ($idChiamata) {
            $query = "
                SELECT c.*,cl.ragioneSociale AS cliente
                FROM #__osma_chiamate AS c
                LEFT JOIN #__osma_anagrafica_clienti AS cl ON c.idCliente=cl.idCliente
                WHERE idChiamata = " . $idChiamata;
            $db->setQuery($query);
            $chiamata = $db->loadObject();

            $query = "SELECT *
                FROM #__osma_chiamata_interventi
                WHERE idChiamata=" . $idChiamata . " ORDER BY idIntervento ASC";
            $db->setQuery($query);
            $chiamata->interventi = $db->loadObjectList();

            foreach ($chiamata->interventi as $i => $intervento) {
                $query = "
                    SELECT idUser
                    FROM #__osma_xref_intervento_utenti
                    WHERE idIntervento=" . $intervento->idIntervento;
                $db->setQuery($query);
                $chiamata->interventi[$i]->team = $db->loadColumn();

                $query = "
                    SELECT  *
                    FROM    #__osma_xref_intervento_documenti
                    WHERE   idIntervento = " . $intervento->idIntervento;
                $db->setQuery($query);
                $chiamata->interventi[$i]->files = $db->loadObjectList();

                $query = "
                    SELECT  *
                    FROM    #__osma_duvri d LEFT OUTER JOIN #__osma_duvri_rapporto r ON r.idDuvri = d.id
                    WHERE   d.idIntervento = " . $intervento->idIntervento;
                $db->setQuery($query);

                $chiamata->interventi[$i]->duvri = $db->loadObject();

                if ($chiamata->interventi[$i]->duvri->id) {
                    $chiamata->interventi[$i]->rapporto = $this->getrapporto($chiamata->interventi[$i]->duvri->id);
                    $chiamata->interventi[$i]->hasDichiarazione = false;
                    if ($chiamata->interventi[$i]->rapporto->distributori) {
                        foreach ($chiamata->interventi[$i]->rapporto->distributori as $pistola) {
                            if ($pistola->normativa == 'nazionale' && $pistola->piombi) {
                                $chiamata->interventi[$i]->hasDichiarazione = true;
                                break;
                            }
                        }
                    }
                }

                $query = "
                    SELECT  *
                    FROM    #__osma_chiamata_interventi_files
                    WHERE   tipoFile = 1 AND idIntervento = " . $intervento->idIntervento . "
                    ORDER   BY idFile";
                $db->setQuery($query);
                $files = $db->loadObjectList();
                if ($files) {
                    $chiamata->interventi[$i]->allegati[1] = $files;
                }

                $query = "
                        SELECT  *
                        FROM    #__osma_chiamata_interventi_files
                        WHERE   tipoFile = 2 AND idIntervento = " . $intervento->idIntervento . "
                        ORDER   BY idFile";

                $db->setQuery($query);
                $files = $db->loadObjectList();
                if ($files) {
                    $chiamata->interventi[$i]->allegati[2] = $files;
                }

                $query = "
                        SELECT  idLibretto, inserted, matricolaPistola, marca, modello
                        FROM    #__osma_rapporto_libretti_metrologici LI
                            INNER JOIN #__osma_anagrafica_pistole PI on PI.idPistola = LI.idMatricola
                            INNER JOIN #__osma_anagrafica_matricole MA on MA.idMatricola = PI.idMatricola
                            INNER JOIN #__osma_anagrafica_marche MR on MA.idMarca = MR.idMarca
                            INNER JOIN #__osma_anagrafica_modelli MO on MA.idModello = MO.idModello
                        WHERE   idIntervento = " . $intervento->idIntervento . "
                        ORDER   BY inserted";

                $db->setQuery($query);
                $librettiMetrologici = $db->loadObjectList();
                if ($librettiMetrologici) {
                    $chiamata->interventi[$i]->librettiMetrologici = $librettiMetrologici;
                }
            }
        }

        return $chiamata;
    }

    public function getrapporto($idDuvri)
    {
        $dbo = JFactory::getDBO();

        $query = $dbo->getQuery(true);
        $query->select("*")
            ->from("#__osma_duvri_rapporto")
            ->where("idDuvri = " . $dbo->q($idDuvri));

        $dbo->setQuery($query, 0, 1);
        $rapporto = $dbo->loadObject();

        if ($rapporto) {
            $query = $dbo->getQuery(true);
            $query->select("d.*, LTRIM(RTRIM(LOWER(normativa))) as normativa")
                ->from("#__osma_duvri_rapporto_distributori d")
                ->leftJoin("#__osma_anagrafica_pistole p ON p.idPistola = d.idMatricola")
                ->leftJoin("#__osma_anagrafica_matricole m ON m.idMatricola = p.idMatricola")
                ->where("m.deleted = 0")
                ->where("idRapporto = " . $dbo->q($rapporto->idRapporto));
            $dbo->setQuery($query);

            $rapporto->distributori = $dbo->loadObjectList();
            $query->clear();

            $query->select("*")
                ->from("#__osma_duvri_rapporto_pagamenti")
                ->where("idRapporto = " . $dbo->q($rapporto->idRapporto));
            $dbo->setQuery($query);
            $rapporto->pagamenti = $dbo->loadObjectList();
            $query->clear();

            $query->select("*")
                ->from("#__osma_duvri_rapporto_materiale")
                ->where("idRapporto = " . $dbo->q($rapporto->idRapporto));
            $dbo->setQuery($query);
            $rapporto->materiale = $dbo->loadObjectList();
        }

        return $rapporto;
    }

    public function getAllegati()
    {

        $idChiamata = JRequest::getVar('idChiamata');
        if (!$idChiamata) {
            return;
        }

        if (is_dir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/allegati/")) {
            $files = scandir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/allegati/");
            foreach ($files as $k => $file) {
                if ($file == "." || $file == "..") {
                    unset($files[$k]);
                } else {
                    $files[$k] = array(
                        "path" => JURI::root() . "components/com_osma/files/chiamate/{$idChiamata}/allegati/{$file}",
                        "name" => $file
                    );
                }
            }
            $files = array_values($files);
            return $files;
        }
        return null;
    }

    public function getRdl()
    {

        $idChiamata = JRequest::getVar('idChiamata');
        if (!$idChiamata) {
            return;
        }

        if (is_dir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/rdl/")) {
            $files = scandir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/rdl/");
            foreach ($files as $k => $file) {
                if ($file == "." || $file == "..") {
                    unset($files[$k]);
                } else {
                    $files[$k] = array(
                        "path" => JURI::root() . "components/com_osma/files/chiamate/{$idChiamata}/rdl/{$file}",
                        "name" => $file
                    );
                }
            }
            $files = array_values($files);
            return $files;
        }
        return null;
    }

    public function getDdt()
    {

        $idChiamata = JRequest::getVar('idChiamata');
        if (!$idChiamata) {
            return;
        }

        if (is_dir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/ddt/")) {
            $files = scandir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/ddt/");
            foreach ($files as $k => $file) {
                if ($file == "." || $file == "..") {
                    unset($files[$k]);
                } else {
                    $files[$k] = array(
                        "path" => JURI::root() . "components/com_osma/files/chiamate/{$idChiamata}/ddt/{$file}",
                        "name" => $file
                    );
                }
            }
            $files = array_values($files);
            return $files;
        }
        return null;
    }

    public function getEmail()
    {

        $idChiamata = JRequest::getVar('idChiamata');
        if (!$idChiamata) {
            return;
        }

        if (is_dir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/email/")) {
            $files = scandir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/email/");
            foreach ($files as $k => $file) {
                if ($file == "." || $file == "..") {
                    unset($files[$k]);
                } else {
                    $files[$k] = array(
                        "path" => JURI::root() . "components/com_osma/files/chiamate/{$idChiamata}/email/{$file}",
                        "name" => $file
                    );
                }
            }
            $files = array_values($files);
            return $files;
        }
        return null;
    }

    public function getImmagini()
    {

        $idChiamata = JRequest::getVar('idChiamata');
        if (!$idChiamata) {
            return;
        }

        if (is_dir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/immagini/")) {
            $files = scandir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/immagini/");
            foreach ($files as $k => $file) {
                if ($file == "." || $file == "..") {
                    unset($files[$k]);
                } else {
                    $files[$k] = array(
                        "path" => JURI::root() . "components/com_osma/files/chiamate/{$idChiamata}/immagini/{$file}",
                        "name" => $file
                    );
                }
            }
            $files = array_values($files);
            return $files;
        }
        return null;
    }

    public function getPreventivi()
    {

        $idChiamata = JRequest::getVar('idChiamata');
        if (!$idChiamata) {
            return;
        }

        if (is_dir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/preventivi/")) {
            $files = scandir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/preventivi/");
            foreach ($files as $k => $file) {
                if ($file == "." || $file == "..") {
                    unset($files[$k]);
                } else {
                    $files[$k] = array(
                        "path" => JURI::root() . "components/com_osma/files/chiamate/{$idChiamata}/preventivi/{$file}",
                        "name" => $file
                    );
                }
            }
            $files = array_values($files);
            return $files;
        }
        return null;
    }

    public function getSicurezza()
    {

        $idChiamata = JRequest::getVar('idChiamata');
        if (!$idChiamata) {
            return;
        }

        if (is_dir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/sicurezza/")) {
            $files = scandir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/sicurezza/");
            foreach ($files as $k => $file) {
                if ($file == "." || $file == "..") {
                    unset($files[$k]);
                } else {
                    $files[$k] = array(
                        "path" => JURI::root() . "components/com_osma/files/chiamate/{$idChiamata}/sicurezza/{$file}",
                        "name" => $file
                    );
                }
            }
            $files = array_values($files);
            return $files;
        }
        return null;
    }

    public function getGenerici()
    {

        $idChiamata = JRequest::getVar('idChiamata');
        if (!$idChiamata) {
            return;
        }

        if (is_dir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/generici/")) {
            $files = scandir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/generici/");
            foreach ($files as $k => $file) {
                if ($file == "." || $file == "..") {
                    unset($files[$k]);
                } else {
                    $files[$k] = array(
                        "path" => JURI::root() . "components/com_osma/files/chiamate/{$idChiamata}/generici/{$file}",
                        "name" => $file
                    );
                }
            }
            $files = array_values($files);
            return $files;
        }
        return null;
    }

    public function getGestori()
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query->select("ag.idGestore, ag.ragioneSociale, ag.indirizzo, ag.comune, ag.provincia, ag.nrPuntoVendita, ac.compagnia")
            ->from("#__osma_anagrafica_gestori AS ag")
            ->leftJoin("#__osma_anagrafica_compagnie AS ac ON ag.idCompagnia = ac.idCompagnia")
            ->order("ragioneSociale ASC");

        if (osmaHelper::isAccessLevel(COM_OSMA_AL_UTENZE)) {
            if (osmaHelper::isGroup(COM_OSMA_GR_CLIENTI)) {
                $query->where("ag.idCliente = " . osmaHelper::getUtenza('idCliente', 'cliente'));
            } elseif (osmaHelper::isGroup(COM_OSMA_GR_GESTORI)) {
                $query->where("ag.idGestore = " . osmaHelper::getUtenza('idGestore', 'gestore'));
            }
        }

        $db->setQuery($query);

        return $db->loadObjectList();
    }

    public function getMezzi()
    {
        $db = JFactory::getDbo();
        $query = "SELECT idMezzo,marca,modello,targa FROM #__osma_anagrafica_mezzi WHERE 1 ORDER BY marca ASC ,modello ASC";
        $db->setQuery($query);
        $mezzi = $db->loadObjectList();

        return $mezzi;
    }

    public function getMezzi2()
    {
        $db = JFactory::getDbo();
        $query = "SELECT idMezzo,marca,modello,targa FROM #__osma_anagrafica_mezzi WHERE 1 ORDER BY marca ASC ,modello ASC";
        $db->setQuery($query);
        $mezzi = $db->loadObjectList();

        echo json_encode($mezzi);
    }

    public function getManutentori()
    {
        $db = JFactory::getDbo();
        $query = "SELECT u.id,u.name
            FROM #__osma_anagrafica_manutentori AS m
            INNER JOIN #__users AS u ON u.id = m.idUser
            ORDER BY u.name ASC";
        $db->setQuery($query);
        $manutentori = $db->loadObjectList();

        return $manutentori;
    }

    public function getManutentori2()
    {
        $db = JFactory::getDBO();
        $query = "SELECT u.id,u.name FROM #__users AS u
    RIGHT JOIN #__osma_anagrafica_manutentori AS m ON u.id=m.idUser
    WHERE 1 ORDER BY u.name ASC";
        $db->setQuery($query);
        $results = $db->loadObjectList();

        echo json_encode($results);
    }

    public function getInterventi()
    {
        $db = JFactory::getDbo();
        $idChiamata = JRequest::getVar('idChiamata');
        $interventi = array();

        if ($idChiamata) {
            $query = "SELECT * FROM #__osma_chiamata_interventi WHERE idChiamata = " . $idChiamata;
            $db->setQuery($query);
            $interventi = $db->loadObject();
        }
        return $interventi;
    }

    public function getMezzoAssociato()
    {
        $db = JFactory::getDbo();
        $idUser = JRequest::getVar('idUser');
        $query = "SELECT idMezzo
    FROM #__osma_anagrafica_manutentori
    WHERE idUser=" . $idUser;
        $db->setQuery($query);
        $idMezzo = $db->loadObject();

        echo json_encode($idMezzo);
    }

    public function getClienteNrChiamata()
    {
        $db = JFactory::getDbo();
        $dataApertura = JRequest::getVar('dataApertura');
        $idGestore = JRequest::getVar('idGestore');

        //trovo anno
        $anno = explode("/", $dataApertura);
        $anno = explode(" ", $anno[2]);
        $anno = $anno[0];

        $query = "SELECT g.idCliente,g.idCompagnia,c.ragioneSociale,c.sigla,c.logoRapportino
    FROM #__osma_anagrafica_gestori AS g
    LEFT JOIN #__osma_anagrafica_clienti AS c ON g.idCliente=c.idCliente
    WHERE g.idGestore=" . $idGestore;
        $db->setQuery($query);
        $dati = $db->loadObject();

        $query = "SELECT contatore
    FROM #__osma_contatori_annuali_clienti
    WHERE idCliente=" . $dati->idCliente . " AND anno=" . $anno;
        $db->setQuery($query);
        $cont = $db->loadResult();
        $dati->anno = $anno;
        if ($cont) {
            $dati->contatore = $cont + 1;
        } else {
            $dati->contatore = 1;
        }

        echo json_encode($dati);
    }

    public function salva()
    {

        $db = JFactory::getDBO();
        $idChiamata = JRequest::getVar('idChiamata');
        $anno = "";
        $interventi = JRequest::getVar('interventi');

        //dati chiamata
        $chiamata = new stdClass();
        $chiamata->stato = $stato = JRequest::getVar('stato');
        $chiamata->tipo = $tipo = JRequest::getVar('tipo');
        $chiamata->canale = $canale = JRequest::getVar('canale');
        $dataApertura = JRequest::getVar('dataApertura');
        $dataScadenza = JRequest::getVar('dataScadenza');
        $chiamata->idScadenza = JRequest::getVar('idScadenza');
        $idCliente = $chiamata->idCliente = JRequest::getVar('idCliente');
        $chiamata->idGestore = $idGestore = JRequest::getVar('gestore');
        $chiamata->idCompagnia = JRequest::getVar('idCompagnia');
        $chiamata->nrChiamataCompagnia = $nrChiamataCompagnia = JRequest::getVar('nrChiamataCompagnia');
        $chiamata->descrizioneGenerale = $descrizioneGenerale = JRequest::getVar('descrizioneGenerale');
        $chiamata->noteChiamata = $noteChiamata = JRequest::getVar('noteChiamata');
        $chiamata->idLogo = JRequest::getVar('logo');
        $chiamata->consuntivata = JRequest::getVar('consuntivata');
        $chiamata->tipoFatturazione = JRequest::getVar('tipoFatturazione');
        if (JRequest::getVar('importoPreventivo') == "")
            $chiamata->importoPreventivo = 0;
        else
            $chiamata->importoPreventivo = JRequest::getVar('importoPreventivo');

        if ($dataApertura && $dataApertura != "") {
            $chiamata->dataApertura = date("Y-m-d H:i", strtotime(str_replace("/", "-", $dataApertura)));
            $anno = date("Y", strtotime(str_replace("/", "-", $dataApertura)));
        } else {
            $chiamata->dataApertura = "0000-00-00";
        }
        if ($dataScadenza && $dataScadenza != "") {
            $chiamata->dataScadenza = date("Y-m-d H:i", strtotime(str_replace("/", "-", $dataScadenza)));
        } else {
            $chiamata->dataScadenza = "0000-00-00";
        }

        $user = JFactory::getUser();
        $userid = $user->get('id');

        $chiamata->idUserApertura = $userid;

        if ($idChiamata != 0) {
            $chiamata->idChiamata = $idChiamata;
            $db->updateObject('#__osma_chiamate', $chiamata, idChiamata);
            $return[0] = 2;
            $return[1] = $idChiamata;

            if (count($interventi)) {
                //delete interventi di idChiamata
                $query = 'DELETE FROM #__osma_chiamata_interventi WHERE idChiamata = ' . $idChiamata;
                $db->setQuery($query);
                $db->query();

                foreach ($interventi as $int) {

                    $intervento = new stdClass();
                    $intervento->idChiamata = $idChiamata;
                    $intervento->idTipoIntervento = $idTipoIntervento = $int['tipologia'];
                    $intervento->idInviaMailA = $int['invia'];
                    $intervento->idMezzo = $int['mezzo'];
                    $intervento->note = $noteIntervento = $int['note'];
                    $intervento->idMezzo2 = $int['mezzo2'];

                    $db->insertObject('#__osma_chiamata_interventi', $intervento, idIntervento);
                    $idIntervento = $db->insertid();

                    //delete interventi idTipoIntervento
                    $query = 'DELETE FROM #__osma_xref_intervento_utenti WHERE idIntervento=' . $idIntervento . ' AND idChiamata = ' . $idChiamata;
                    $db->setQuery($query);
                    $db->query();

                    foreach ($int['team'] as $j => $t) {
                        $team = new stdClass();
                        $team->idIntervento = $idIntervento;
                        $team->idChiamata = $idChiamata;
                        $team->idUser = $t;
                        $db->insertObject('#__osma_xref_intervento_utenti', $team, id);
                    }

                    $return[0] = 2;
                    $return[1] = $idChiamata;
                }
            }
            $query = "SELECT nrChiamata
                      FROM #__osma_chiamate
                      WHERE idChiamata = " . $idChiamata;
            $db->setQuery($query);
            $dati = $db->loadObject();
            $chiamata->nrChiamata = $dati->nrChiamata;

            $query = "SELECT g.idCliente, g.idCompagnia, c.ragioneSociale, c.sigla, c.logoRapportino, g.ragioneSociale as gRagioneSociale, g.indirizzo as gIndirizzo, g.comune as gComune
                      FROM #__osma_anagrafica_gestori AS g
                      LEFT JOIN #__osma_anagrafica_clienti AS c ON g.idCliente = c.idCliente
                      WHERE g.idGestore = " . $idGestore;
            $db->setQuery($query);
            $dati = $db->loadObject();
            $cRagioneSociale = $dati->ragioneSociale;
            $gRagioneSociale = $dati->gRagioneSociale;
            $gIndirizzo = $dati->gIndirizzo;
            $gComune = $dati->gComune;

            $oggettoMail = "Modifica alla chiamata {$chiamata->nrChiamata}, aperta da {$cRagioneSociale}";
        } else {
            //ricalcolo nr chiamata per evitare doppioni
            $query = "SELECT g.idCliente, g.idCompagnia, c.ragioneSociale, c.sigla, c.logoRapportino, g.ragioneSociale as gRagioneSociale, g.indirizzo as gIndirizzo, g.comune as gComune
                      FROM #__osma_anagrafica_gestori AS g
                      LEFT JOIN #__osma_anagrafica_clienti AS c ON g.idCliente = c.idCliente
                      WHERE g.idGestore = " . $idGestore;
            $db->setQuery($query);
            $dati = $db->loadObject();
            $cRagioneSociale = $dati->ragioneSociale;
            $gRagioneSociale = $dati->gRagioneSociale;
            $gIndirizzo = $dati->gIndirizzo;
            $gComune = $dati->gComune;

            $query = "SELECT contatore
                      FROM #__osma_contatori_annuali_clienti
                      WHERE idCliente=" . $dati->idCliente . " AND anno=" . $anno;
            $db->setQuery($query);
            $cont = $db->loadResult();
            $dati->anno = $anno;
            if ($cont) {
                $c = $cont + 1;
            } else {
                $c = 1;
            }

            if ($c < 10) {
                $contatore = "000" . $c;
            } else if ($c < 100) {
                $contatore = "00" . $c;
            } else if ($c < 1000) {
                $contatore = "0" . $c;
            } else {
                $contatore = $c;
            }
            $chiamata->nrChiamata = $nrChiamata = $dati->sigla . "" . $contatore . "/" . $anno;

            $chiamata->createDate = date('Y-m-d H:i:s');
            $db->insertObject('#__osma_chiamate', $chiamata, idChiamata);
            $idChiamata = $db->insertid();

            //creo cartella dove salverò i documenti dell'ordine
            $dir = JPATH_COMPONENT . "/files/chiamate/" . $idChiamata;
            mkdir($dir);

            //inserisco contatore cliente
            $query = "SELECT idContatore, contatore FROM #__osma_contatori_annuali_clienti WHERE anno = " . $anno . " AND idCliente=" . $idCliente;
            $db->setQuery($query);
            $dati = $db->loadObject();

            if (count($dati) != 0) {
                //update contatore
                $data = new stdClass();
                $data->contatore = $dati->contatore + 1;
                $data->anno = $anno;
                $data->idCliente = $idCliente;
                $data->idContatore = $dati->idContatore;
                $db->updateObject('#__osma_contatori_annuali_clienti', $data, idContatore);
            } else {
                //insert il primo dell anno
                $data = new stdClass();
                $data->contatore = 1;
                $data->anno = $anno;
                $data->idCliente = $idCliente;
                $db->insertObject('#__osma_contatori_annuali_clienti', $data, idContatore);
            }
            $return[0] = 1;
            $return[1] = $idChiamata;

            $oggettoMail = "Nuova chiamata {$chiamata->nrChiamata}, aperta da {$cRagioneSociale}";
        }

        if (osmaHelper::isAccessLevel(COM_OSMA_AL_UTENZE)) {
            $mailer = JFactory::getMailer();

            //set sender
            $mailer->setSender(array(JFactory::getUser()->get("email"), JFactory::getUser()->get("name")));
            $to = array();

            $to[] = COM_OSMA_MAIL_TO;

            if (JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug") && JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address")) {
                $mailer->addCC(JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address"));
            }

            $body = "
                    <p style='font-size: 25px; padding-bottom: 10px; border-bottom: 1px solid #000; margin-bottom: 10px'>Nuova chiamata {$chiamata->nrChiamata}, aperta da {$cRagioneSociale}</p>
                    <p><b>Gestore:</b> {$gRagioneSociale} - {$gIndirizzo}, {$gComune}</p><br>
                    <p>{$chiamata->descrizioneGenerale}</p><br>
                    <p>note chiamata: {$chiamata->noteChiamata}</p><br><br>
                    <p><a href='" . JRoute::_("index.php?option=com_osma&view=chiamata&idChiamata={$idChiamata}", true, -1) . "'>Visualizza la chiamata: " . JRoute::_("index.php?option=com_osma&view=chiamata&idChiamata={$idChiamata}", true, -1) . "</a></p>
                ";

            $mailer->addRecipient($to);
            $mailer->setSubject($oggettoMail);
            $mailer->isHTML(true);
            $mailer->Encoding = 'base64';
            $mailer->setBody($body);

            $mailer->Send();
        }

        if ($chiamata->idScadenza && $chiamata->stato == 4) {
            osmaHelper::aggiornaDataScadenziario($chiamata->idScadenza);
        }

        return $return;
    }

    public function deleteIntervento()
    {
        $db = JFactory::getDBO();
        $idIntervento = JRequest::getVar('idIntervento');

        $query = 'SELECT * FROM #__osma_xref_intervento_documenti WHERE idIntervento = ' . $idIntervento;
        $db->setQuery($query);
        if ($rows = $db->loadObjectList()) {
            foreach ($rows as $file) {
                if (file_exists(JPATH_COMPONENT . '/files/chiamate/' . $file->idChiamata . '/' . $file->fileName)) {
                    if (unlink(JPATH_COMPONENT . '/files/chiamate/' . $file->idChiamata . '/' . $file->fileName)) {
                        $query = 'DELETE FROM #__osma_xref_intervento_documenti WHERE id = ' . $file->id;
                        $db->setQuery($query);
                        $db->query();
                    }
                }
            }
        }

        $query = 'DELETE FROM #__osma_chiamata_interventi WHERE idIntervento = ' . $idIntervento;
        $db->setQuery($query);
        $db->query();

        $query = 'DELETE FROM #__osma_xref_intervento_utenti WHERE idIntervento=' . $idIntervento;
        $db->setQuery($query);
        $db->query();

        return true;
    }

    public function deleteChiamata()
    {
        $db = JFactory::getDBO();
        $idChiamata = JRequest::getVar('idChiamata');

        //cancello chiamata
        $query = 'DELETE FROM #__osma_chiamate WHERE idChiamata = ' . $idChiamata;
        $db->setQuery($query);
        $db->query();

        //cancello interventi
        $query = 'DELETE FROM #__osma_chiamata_interventi WHERE idChiamata = ' . $idChiamata;
        $db->setQuery($query);
        $db->query();

        return true;
    }

    public function getComunicazioni()
    {
        $idChiamata = JRequest::getVar('idChiamata');
        if (!$idChiamata) {
            return;
        }
        $db = JFactory::getDBO();

        $query = $db->getQuery(true);
        $query->select("*")->from("#__osma_chiamate_comunicazioni")->where("idChiamata = {$idChiamata}");

        return $db->setQuery($query)->loadObjectList();
    }

    public function generaPdfArgelato()
    {
        require_once(dirname(__FILE__) . '/../lib/libpdf/tcpdf_include.php');
        $pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
        $pdf->SetCreator(PDF_CREATOR);
        $pdf->SetKeywords('consorzio argelato, argelato, rapportino intervento, intervento argelato');
        //$pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, '', PDF_HEADER_STRING);
        $pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
        $pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));
        $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
        $pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
        $pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
        $pdf->SetFooterMargin(PDF_MARGIN_FOOTER);
        $pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);
        $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);
        if (@file_exists(dirname(__FILE__) . '/../libpdf/lang/ita.php')) {
            require_once(dirname(__FILE__) . '/../libpdf/lang/ita.php');
            $pdf->setLanguageArray($l);
        }
        $pdf->SetFont('helvetica', '', 10);
        $pdf->AddPage();

        $coupon = JRequest::getVar('coupon');
        $db = JFactory::getDbo();
        /* $query = $db->getQuery(true);
          $query->select('a.grammi,a.totale,b.caratura, a.data_inserimento, n.indirizzo, n.negozio, n.citta, n.telefono, n.negozio_id')->from('#__oroexpress_data as a')
          ->join('left','#__oroexpress_carature as b ON b.coefficiente = a.coefficiente')
          ->join('left','#__oroexpress_negozi as n ON n.user_id = a.negozio_scelto')
          ->where('a.codice_coupon="'.$coupon.'"');
          $db->setQuery($query);
          $datiCoupon = $db->loadAssoc();

          $negozioid = $datiCoupon['negozio_id'];
          $query = $db->getQuery(true);
          $query->select('n.negozio, n.telefono, n.indirizzo, n.citta')
          ->from('#__oroexpress_negozi as n')
          ->join('left','#__oroexpress_negozi_vicini as v ON v.vicino_id = n.negozio_id')
          ->where('v.negozio_id ='.$negozioid.' AND n.published=1');
          $db->setQuery($query);
          $vicini = $db->loadObjectList();

          $grammi = $datiCoupon['grammi'];
          $valore = $datiCoupon['totale'];
          $caratura = $datiCoupon['caratura'];
          $negozio = $datiCoupon['negozio'];
          $indirizzo = $datiCoupon['indirizzo'];
          $citta = $datiCoupon['citta'];
          $telefono = $datiCoupon['telefono'];
          $data = $datiCoupon['data_inserimento'];

          $data_scadenza = JHTML::_( 'date', date('Y-m-d H:i', strtotime($datiCoupon['data_inserimento'])+(43200*2)), DATE_FORMAT_LC2);
         */

        /* $html = '<html><head>';
          $html .= '</head><body style="text-align:center;">';
          $html .= '<p>IL CODICE DEL TUO COUPON:</p>
          <h1 style="text-align:center;font-size:45px;"><strong>'.$coupon.'</strong></h1>
          <div class="test">
          <p>Sei in possesso di <strong>'.$grammi.' gr di oro '.$caratura.'</strong></p>
          <h2>Il valore del tuo ORO è <br /><strong style="font-size:30px;">&euro; '.str_replace(".",",",$valore).'</strong></h2>
          <p>Il tuo coupon scadrà <strong>'.JHTML::_( "date", date("Y-m-d H:i", strtotime(date("Y-m-d H:i", strtotime($data)) . " +24 hours")), DATE_FORMAT_LC2).'</strong></p>
          ';
          $html .= '</div></body></html>'; */

        $pdf->SetLineWidth(1.0);
        // set color for cell border
        $pdf->SetDrawColor(254, 234, 0);
        // set color for background
        $pdf->SetFillColor(250, 250, 250);
        // set color for text
        $pdf->SetTextColor(39, 49, 97);
        $pdf->SetCellPaddings(8);
        // write the first column
        //$pdf->writeHTMLCell(180, '', '', $pdf->getY()+10, $html, 1, 0, 1, true, 'C', true);

        $pdf->Ln();
        $pdf->SetLineStyle(array('width' => 0.5, 'cap' => 'butt', 'join' => 'miter', 'solid' => 4, 'color' => array(39, 49, 97)));
        $pdf->SetFillColor(254, 234, 0);
        $pdf->SetTextColor(39, 49, 97);
        $pdf->writeHTMLCell(69, 17, 70, 60, '', 1, 1, 1, 1, 'C', 1);

        $pdf->SetLineWidth(0.2);
        $pdf->Line(30, 114, 180, 114);
        $pdf->Line(30, 122, 180, 122);

        //$pdf->writeHTML($html, true, false, true, false, '');
        $pdf->lastPage();
        $pdf->Output('tmp/argelato.pdf', 'I'); //sostituire I con F per creare il file
        //stampa
        header("Pragma: public");
        header("Expires: 0");
        header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
        header("Cache-Control: public");
        header("Content-Description: File Transfer");
        header("Content-type: application/pdf");
        header('Content-Disposition: attachment; filename="argelato.pdf"');
        header("Content-Transfer-Encoding: binary");
        header("Content-Length: " . filesize('tmp/argelato.pdf'));
        ob_end_flush();
        readfile('tmp/argelato.pdf');
        // remove zip file from temp path
        unlink('tmp/argelato.pdf');
    }

    function upload()
    {
        jimport('joomla.filesystem.file');
        $file = JRequest::getVar('file', null, 'files', 'array');
        $type = JRequest::getVar('type');
        if ($file['tmp_name']) {
            //Import filesystem libraries. Perhaps not necessary, but does not hurt
            jimport('joomla.filesystem.file');
            //Clean up filename to get rid of strange characters like spaces etc
            //Set up the source and destination of the file
            $src = $file['tmp_name'];
            $orig = JPATH_ROOT . DS . 'components' . DS . 'com_osma' . DS . "files" . DS . "chiamate" . DS . "1" . DS . $src;

            //First check if the file has the right extension, we need jpg only

            if (JFile::upload($src, $orig)) {//upload immagine originale
            } else {
                //Redirect and throw an error message
            }
        }
    }

}
