<?php

/**
 * @package     Joomla.Administrator
 * @subpackage  com_helloworld
 *
 * @copyright   Copyright (C) 2005 - 2016 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * HelloWorld Model
 *
 * @since  0.0.1
 */
class OsmaModelProdotti extends JModelList {

    public function getItems() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query, $this->limitstart, $this->limit);
        $results = $db->loadObjectList();
        return $results;
    }

    public function getTotal() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query);
        $db->query();
        $results = $db->getNumRows();
        return $results;
    }

    protected function populateState($ordering = null, $direction = null) {
        $app = JFactory::getApplication('administrator');

        $search = $app->getUserStateFromRequest($this->context . '.filter.search', 'filter_search');
        //Omit double (white-)spaces and set state
        $this->setState('filter.search', preg_replace('/\s+/', ' ', $search));
        parent::populateState('ordering', 'ASC');
    }

    public function __construct($config = array()) {
        $config['filter_fields'] = array(
            'ordering',
            'search'
        );
        parent::__construct($config);
        $mainframe = JFactory::getApplication();
        $this->limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $this->limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $this->limitstart = ($this->limit != 0 ? (floor($this->limitstart / $this->limit) * $this->limit) : 0);

        $this->setState('limit', $this->limit);
        $this->setState('limitstart', $this->limitstart);
    }

    public function costruisciQuery() {
        //$filterCompanyName = JRequest::getVar('filterCompanyName');

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $search = $db->escape($this->getState('filter.search'));

        if (empty($search)) {
            $query = "SELECT * FROM #__osma_anagrafica_prodotti_erogati WHERE deleted = 0 ORDER BY prodottoErogato ASC";
        } else {
            $search = $db->Quote('%' . $db->escape($search, true) . '%');

            $query = "  SELECT * 
                        FROM #__osma_anagrafica_prodotti_erogati
                        WHERE deleted = 0 AND published = 1";
            $query .= " AND (prodottoErogato LIKE " . $search . " OR siglaRapportino LIKE " . $search .")";
            $query .= " ORDER BY prodottoErogato ASC";
        }

        return $query;
    }

    function pubblica() {
        $ids = JRequest::getVar("ids");
        $db = JFactory::getDBO();

        foreach ($ids AS $idProdottoErogato) {
            $query = "UPDATE #__osma_anagrafica_prodotti_erogati
                SET published=1
                WHERE idProdottoErogato=" . $idProdottoErogato;
            $db->setQuery($query);
            $db->query();
        }
        return true;
    }

    function sospendi() {
        $ids = JRequest::getVar("ids");
        $db = JFactory::getDBO();

        foreach ($ids AS $idProdottoErogato) {
            $query = "UPDATE #__osma_anagrafica_prodotti_erogati
                SET published=0
                WHERE idProdottoErogato=" . $idProdottoErogato;
            $db->setQuery($query);
            $db->query();
        }
        return true;
    }

    function rimuovi() {
        $ids = JRequest::getVar("ids");
        $db = JFactory::getDBO();

        foreach ($ids AS $idProdottoErogato) {
            $query = "UPDATE #__osma_anagrafica_prodotti_erogati
      SET deleted=1
      WHERE idProdottoErogato=" . $idProdottoErogato;
            $db->setQuery($query);
            $db->query();
        }
        return true;
    }

    function salva() {
        $db = JFactory::getDBO();

        $id = JRequest::getVar("id");

        $prodotto = JRequest::getVar("dataToSave");
        $sigla = JRequest::getVar("siglaRapportino");
        
        $data = new stdClass();
        $data->prodottoErogato = $prodotto;
        $data->siglaRapportino = $sigla;
        $data->published = 1;
        $data->deleted = 0;

        if ($id) {
            //modifica
            $data->idProdottoErogato = $id;
            $db->updateObject('#__osma_anagrafica_prodotti_erogati', $data, idProdottoErogato);
            $result = $db->getErrorMsg();
        } else {
            $data->createDate = date('Y-m-d H:i:s');
            //salva
            $db->insertObject('#__osma_anagrafica_prodotti_erogati', $data, idProdottoErogato);
            $id = $db->insertid();
            $result = $db->getErrorMsg();
        }

        echo $result;
    }

}
