<?php

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class OsmaViewAmministrazione extends JViewLegacy {

    function display($tpl = null) {

        $this->items = $this->get("Items");

        $this->title = JText::_("COM_OSMA_AMMINISTRAZIONE");

        switch (JRequest::getVar("layout")) {
            case 'pistole-scadenza':
                $ids = array();
                foreach ($this->items as $pistola) {
                    if (in_array($pistola->idGestore, $ids)) {
                        continue;
                    }
                    $ids[] = $pistola->idGestore;

                    $items[$pistola->idGestore] = array(
                        'gestore' => array(
                            'idGestore' => $pistola->idGestore,
                            'ragioneSociale' => $pistola->gRagioneSociale,
                            'comune' => $pistola->gComune,
                            'indirizzo' => $pistola->gIndirizzo,
                            'cap' => $pistola->gCap,
                            'provincia' => $pistola->gProvincia,
                            'nrRea' => $pistola->gRea,
                        ),
                    );
                }
                foreach ($this->items as $pistola) {
                    $items[$pistola->idGestore]['cliente'] = array(
                        'idCliente' => $pistola->idCliente,
                        'ragioneSociale' => $pistola->cRagioneSociale,
                        'comune' => $pistola->cComune,
                        'indirizzo' => $pistola->cIndirizzo,
                        'cap' => $pistola->cCap,
                        'provincia' => $pistola->cProvincia,
                    );
                }
                foreach ($this->items as $pistola) {
                    $items[$pistola->idGestore]['pistole'][] = $pistola;
                }
                $this->items = $items;
                break;
            case 'genera-preventivo':
                $this->banche = $this->get("Banche");
                $this->codiciMagazzino = $this->get("codiciMagazzino");

                if (JRequest::getVar("idPreventivo")) {
                    $this->preventivo = $this->get("Preventivo");
                    $this->destinazione = (object) unserialize($this->preventivo->destinazione);
                    $this->spettabile = (object) unserialize($this->preventivo->spettabile);
                    if ($this->preventivo->idCliente) {
                        $this->cliente = osmaHelper::getCliente($this->preventivo->idCliente);
                    }
                    if ($this->preventivo->idGestore) {
                        $this->gestore = osmaHelper::getGestore($this->preventivo->idGestore);
                    }
                } else {
                    if ($this->items) {
                        $this->cliente = osmaHelper::getCliente($this->items[0]->idCliente);
                        $this->gestore = osmaHelper::getGestore($this->items[0]->idGestore);
                    }
                }
                break;
            case 'genera-rvmp':
                if (JRequest::getVar("idPreventivo")) {
                    $preventivo = osmaHelper::getPreventivo(JRequest::getVar("idPreventivo"));
                    if (JRequest::getVar("idCliente")) {
                        $this->cliente = osmaHelper::getCliente(JRequest::getVar("idCliente"));
                    } else {
                        $this->cliente = (object) unserialize($preventivo->spettabile);
                    }
                    if (JRequest::getVar("idGestore")) {
                        $this->gestore = osmaHelper::getGestore(JRequest::getVar("idGestore"));
                    } else {
                        $this->gestore = (object) unserialize($preventivo->destinazione);
                    }
                } elseif (JRequest::getVar("idRichiesta")) {
                    $this->richiesta = $this->items;
                    unset($this->items);
                }
                $this->preventivi = $this->get("ElencoPreventivi");
                $this->ultimoProgressivo = $this->get("UltimoProgressivo");
                break;
            case 'scadenziario':
                $this->total = $this->get("Total");
                $this->pagination = $this->get("Pagination");

                $this->gestori = $this->get("Gestori");
            case 'elenco-rvmp':
            case 'elenco-preventivi':
                $this->total = $this->get("Total");
                $this->pagination = $this->get("Pagination");
                break;
            case 'email-logger':
                $this->sections = $this->get("EmailSections");
                $this->total = $this->get("Total");
                $this->pagination = $this->get("Pagination");
                break;
            case 'default':
            default:
                break;
        }

        JFactory::getDocument()->addScript(JURI::base() . 'components/com_osma/assets/js/view-amministrazione.js?ver=' . COM_OSMA_VER, "text/javascript");
        JFactory::getDocument()->addStyleSheet(JURI::base() . 'components/com_osma/assets/css/view-amministrazione.css?ver=' . COM_OSMA_VER);

        $this->pagination	= $this->get('Pagination');
        if (count($errors = $this->get('Errors'))) {
            JError::raiseError(500, implode('<br />', $errors));
            return false;
        }

        parent::display($tpl);
    }

}
